diff --git a/po/POTFILES.in b/po/POTFILES.in
index 2256cb2..7fbbe8f 100644
--- a/po/POTFILES.in
+++ b/po/POTFILES.in
@@ -119,6 +119,7 @@ src/xen/xm_internal.c
 src/xen/xs_internal.c
 src/xenapi/xenapi_driver.c
 src/xenapi/xenapi_utils.c
+src/xenxs/xen_sxpr.c
 tools/console.c
 tools/libvirt-guests.init.sh
 tools/virsh.c
diff --git a/src/Makefile.am b/src/Makefile.am
index 5c9b019..1e670e5 100644
--- a/src/Makefile.am
+++ b/src/Makefile.am
@@ -423,6 +423,10 @@ CPU_SOURCES =							\
 VMX_SOURCES =							\
 		vmx/vmx.c vmx/vmx.h
 
+XENXS_SOURCES =							\
+		xenxs/xenxs_private.h				\
+		xenxs/xen_sxpr.c xenxs/xen_sxpr.h
+
 pkgdata_DATA =	cpu/cpu_map.xml
 
 EXTRA_DIST +=	$(pkgdata_DATA)
@@ -464,6 +468,14 @@ libvirt_vmx_la_CFLAGS = \
 libvirt_vmx_la_SOURCES = $(VMX_SOURCES)
 endif
 
+if WITH_XEN
+noinst_LTLIBRARIES += libvirt_xenxs.la
+libvirt_la_BUILT_LIBADD += libvirt_xenxs.la
+libvirt_xenxs_la_CFLAGS = \
+		-I@top_srcdir@/src/conf $(AM_CFLAGS)
+libvirt_xenxs_la_SOURCES = $(XENXS_SOURCES)
+endif
+
 
 noinst_LTLIBRARIES += libvirt_driver.la
 libvirt_la_BUILT_LIBADD += libvirt_driver.la
@@ -583,6 +595,7 @@ endif
 libvirt_driver_xen_la_CFLAGS =					\
 		$(XEN_CFLAGS)					\
 		-I@top_srcdir@/src/conf				\
+		-I@top_srcdir@/src/xenxs			\
 		$(AM_CFLAGS)
 libvirt_driver_xen_la_LDFLAGS = $(AM_LDFLAGS)
 libvirt_driver_xen_la_LIBADD = $(XEN_LIBS)
diff --git a/src/xen/xen_driver.c b/src/xen/xen_driver.c
index b14c8db..6e3028a 100644
--- a/src/xen/xen_driver.c
+++ b/src/xen/xen_driver.c
@@ -33,6 +33,7 @@
 #include "datatypes.h"
 #include "xen_driver.h"
 
+#include "xen_sxpr.h"
 #include "xen_hypervisor.h"
 #include "xend_internal.h"
 #include "xs_internal.h"
@@ -1198,6 +1199,9 @@ xenUnifiedDomainXMLFromNative(virConnectPtr conn,
     virDomainDefPtr def = NULL;
     char *ret = NULL;
     virConfPtr conf = NULL;
+    int id;
+    char * tty;
+    int vncport;
     GET_PRIVATE(conn);
 
     if (STRNEQ(format, XEN_CONFIG_FORMAT_XM) &&
@@ -1214,7 +1218,13 @@ xenUnifiedDomainXMLFromNative(virConnectPtr conn,
 
         def = xenXMDomainConfigParse(conn, conf);
     } else if (STREQ(format, XEN_CONFIG_FORMAT_SEXPR)) {
-        def = xenDaemonParseSxprString(conn, config, priv->xendConfigVersion);
+        id = xenGetDomIdFromSxprString(config, priv->xendConfigVersion);
+        xenUnifiedLock(priv);
+        tty = xenStoreDomainGetConsolePath(conn, id);
+        vncport = xenStoreDomainGetVNCPort(conn, id);
+        xenUnifiedUnlock(priv);
+        def = xenDaemonParseSxprString(config, priv->xendConfigVersion, tty,
+                                       vncport);
     }
     if (!def)
         goto cleanup;
diff --git a/src/xen/xend_internal.c b/src/xen/xend_internal.c
index 6f98dc0..70f6ac4 100644
--- a/src/xen/xend_internal.c
+++ b/src/xen/xend_internal.c
@@ -38,6 +38,7 @@
 #include "driver.h"
 #include "util.h"
 #include "sexpr.h"
+#include "xen_sxpr.h"
 #include "buf.h"
 #include "uuid.h"
 #include "xen_driver.h"
